"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api.types import BaseModel
from clerk_backend_api.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from typing import List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class CreateOrganizationInvitationBulkPublicMetadataTypedDict(TypedDict):
    r"""Metadata saved on the organization invitation, read-only from the Frontend API and fully accessible (read/write) from the Backend API."""
    
    

class CreateOrganizationInvitationBulkPublicMetadata(BaseModel):
    r"""Metadata saved on the organization invitation, read-only from the Frontend API and fully accessible (read/write) from the Backend API."""
    
    

class CreateOrganizationInvitationBulkPrivateMetadataTypedDict(TypedDict):
    r"""Metadata saved on the organization invitation, fully accessible (read/write) from the Backend API but not visible from the Frontend API."""
    
    

class CreateOrganizationInvitationBulkPrivateMetadata(BaseModel):
    r"""Metadata saved on the organization invitation, fully accessible (read/write) from the Backend API but not visible from the Frontend API."""
    
    

class RequestBodyTypedDict(TypedDict):
    email_address: str
    r"""The email address of the new member that is going to be invited to the organization"""
    inviter_user_id: str
    r"""The ID of the user that invites the new member to the organization.
    Must be an administrator in the organization.
    """
    role: str
    r"""The role of the new member in the organization."""
    public_metadata: NotRequired[CreateOrganizationInvitationBulkPublicMetadataTypedDict]
    r"""Metadata saved on the organization invitation, read-only from the Frontend API and fully accessible (read/write) from the Backend API."""
    private_metadata: NotRequired[CreateOrganizationInvitationBulkPrivateMetadataTypedDict]
    r"""Metadata saved on the organization invitation, fully accessible (read/write) from the Backend API but not visible from the Frontend API."""
    redirect_url: NotRequired[str]
    r"""Optional URL that the invitee will be redirected to once they accept the invitation by clicking the join link in the invitation email."""
    

class RequestBody(BaseModel):
    email_address: str
    r"""The email address of the new member that is going to be invited to the organization"""
    inviter_user_id: str
    r"""The ID of the user that invites the new member to the organization.
    Must be an administrator in the organization.
    """
    role: str
    r"""The role of the new member in the organization."""
    public_metadata: Optional[CreateOrganizationInvitationBulkPublicMetadata] = None
    r"""Metadata saved on the organization invitation, read-only from the Frontend API and fully accessible (read/write) from the Backend API."""
    private_metadata: Optional[CreateOrganizationInvitationBulkPrivateMetadata] = None
    r"""Metadata saved on the organization invitation, fully accessible (read/write) from the Backend API but not visible from the Frontend API."""
    redirect_url: Optional[str] = None
    r"""Optional URL that the invitee will be redirected to once they accept the invitation by clicking the join link in the invitation email."""
    

class CreateOrganizationInvitationBulkRequestTypedDict(TypedDict):
    organization_id: str
    r"""The organization ID."""
    request_body: List[RequestBodyTypedDict]
    

class CreateOrganizationInvitationBulkRequest(BaseModel):
    organization_id: Annotated[str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))]
    r"""The organization ID."""
    request_body: Annotated[List[RequestBody], FieldMetadata(request=RequestMetadata(media_type="application/json"))]
    
