"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from .invitation import Invitation, InvitationTypedDict
from clerk_backend_api.types import BaseModel
from clerk_backend_api.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Callable, List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class ListInvitationsQueryParamStatus(str, Enum):
    r"""Filter invitations based on their status"""
    PENDING = "pending"
    ACCEPTED = "accepted"
    REVOKED = "revoked"

class ListInvitationsRequestTypedDict(TypedDict):
    limit: NotRequired[float]
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """
    offset: NotRequired[float]
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """
    status: NotRequired[ListInvitationsQueryParamStatus]
    r"""Filter invitations based on their status"""
    

class ListInvitationsRequest(BaseModel):
    limit: Annotated[Optional[float], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = 10
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """
    offset: Annotated[Optional[float], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = 0
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """
    status: Annotated[Optional[ListInvitationsQueryParamStatus], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = None
    r"""Filter invitations based on their status"""
    

class ListInvitationsResponseTypedDict(TypedDict):
    result: List[InvitationTypedDict]
    

class ListInvitationsResponse(BaseModel):
    next: Callable[[], Optional[ListInvitationsResponse]]
    
    result: List[Invitation]
    
