"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from enum import Enum
from pydantic import model_serializer
from typing import List, Optional, TypedDict
from typing_extensions import NotRequired


class SignUpObject(str, Enum):
    SIGN_UP_ATTEMPT = "sign_up_attempt"

class SignUpStatus(str, Enum):
    MISSING_REQUIREMENTS = "missing_requirements"
    COMPLETE = "complete"
    ABANDONED = "abandoned"

class VerificationsTypedDict(TypedDict):
    pass
    

class Verifications(BaseModel):
    pass
    

class SignUpUnsafeMetadataTypedDict(TypedDict):
    pass
    

class SignUpUnsafeMetadata(BaseModel):
    pass
    

class SignUpPublicMetadataTypedDict(TypedDict):
    pass
    

class SignUpPublicMetadata(BaseModel):
    pass
    

class ExternalAccountTypedDict(TypedDict):
    pass
    

class ExternalAccount(BaseModel):
    pass
    

class SignUpTypedDict(TypedDict):
    object: SignUpObject
    id: str
    status: SignUpStatus
    password_enabled: bool
    custom_action: bool
    abandon_at: int
    required_fields: NotRequired[List[str]]
    optional_fields: NotRequired[List[str]]
    missing_fields: NotRequired[List[str]]
    unverified_fields: NotRequired[List[str]]
    verifications: NotRequired[VerificationsTypedDict]
    username: NotRequired[Nullable[str]]
    email_address: NotRequired[Nullable[str]]
    phone_number: NotRequired[Nullable[str]]
    web3_wallet: NotRequired[Nullable[str]]
    first_name: NotRequired[Nullable[str]]
    last_name: NotRequired[Nullable[str]]
    unsafe_metadata: NotRequired[SignUpUnsafeMetadataTypedDict]
    public_metadata: NotRequired[SignUpPublicMetadataTypedDict]
    external_id: NotRequired[Nullable[str]]
    created_session_id: NotRequired[Nullable[str]]
    created_user_id: NotRequired[Nullable[str]]
    external_account: NotRequired[ExternalAccountTypedDict]
    

class SignUp(BaseModel):
    object: SignUpObject
    id: str
    status: SignUpStatus
    password_enabled: bool
    custom_action: bool
    abandon_at: int
    required_fields: Optional[List[str]] = None
    optional_fields: Optional[List[str]] = None
    missing_fields: Optional[List[str]] = None
    unverified_fields: Optional[List[str]] = None
    verifications: Optional[Verifications] = None
    username: OptionalNullable[str] = UNSET
    email_address: OptionalNullable[str] = UNSET
    phone_number: OptionalNullable[str] = UNSET
    web3_wallet: OptionalNullable[str] = UNSET
    first_name: OptionalNullable[str] = UNSET
    last_name: OptionalNullable[str] = UNSET
    unsafe_metadata: Optional[SignUpUnsafeMetadata] = None
    public_metadata: Optional[SignUpPublicMetadata] = None
    external_id: OptionalNullable[str] = UNSET
    created_session_id: OptionalNullable[str] = UNSET
    created_user_id: OptionalNullable[str] = UNSET
    external_account: Optional[ExternalAccount] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["nullableOptional", "optional"]
        nullable_fields = ["nullableRequired", "nullableOptional"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields
                or (
                    k in optional_fields
                    and k in nullable_fields
                    and (
                        self.__pydantic_fields_set__.intersection({n})
                        or k in null_default_fields
                    )  # pylint: disable=no-member
                )
            ):
                m[k] = val

        return m
        
