"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""


from ._hooks import SDKHooks
from .httpclient import AsyncHttpClient, HttpClient
from .utils import RetryConfig, remove_suffix
from clerk_backend_api import models
from clerk_backend_api.types import Nullable, UNSET
from dataclasses import dataclass
from typing import Callable, Dict, Optional, Tuple, Union


SERVERS = [
    "https://api.clerk.com/v1",
]
"""Contains the list of servers available to the SDK"""

@dataclass
class SDKConfiguration:
    client: HttpClient
    async_client: AsyncHttpClient
    security: Optional[Union[models.Security,Callable[[], models.Security]]] = None
    server_url: Optional[str] = ""
    server_idx: Optional[int] = 0
    language: str = "python"
    openapi_doc_version: str = "v1"
    sdk_version: str = "0.5.0-alpha.8"
    gen_version: str = "2.370.2"
    user_agent: str = "speakeasy-sdk/python 0.5.0-alpha.8 2.370.2 v1 clerk-backend-api"
    retry_config: Optional[Nullable[RetryConfig]] = UNSET
    timeout_ms: Optional[int] = None

    def __post_init__(self):
        self._hooks = SDKHooks()

    def get_server_details(self) -> Tuple[str, Dict[str, str]]:
        if self.server_url is not None and self.server_url:
            return remove_suffix(self.server_url, "/"), {}
        if self.server_idx is None:
            self.server_idx = 0

        return SERVERS[self.server_idx], {}


    def get_hooks(self) -> SDKHooks:
        return self._hooks
